Index: src/kernel_config.h
===================================================================
--- src/kernel_config.h	(revision 0)
+++ src/kernel_config.h	(revision 0)
@@ -0,0 +1,16 @@
+/* 
+ * This contains functions declaractions used by ndt to tweak kernel settings.
+ * This uses the /proc/sys interface.
+ * 
+ * Author: Richard Sanger
+ */
+ 
+#ifndef SRC_KERNEL_CONFIG_H_
+#define SRC_KERNEL_CONFIG_H_
+
+int check_kernel(int autofix);
+int revert_congestion();
+int start_tcpe();
+int revert_tcpe();
+
+#endif  // SRC_KERNEL_CONFIG_H_
Index: src/test_c2s_srv.c
===================================================================
--- src/test_c2s_srv.c	(revision 796)
+++ src/test_c2s_srv.c	(working copy)
@@ -61,10 +61,13 @@
  *			-102 - Retries exceeded while waiting for data from connected client
  *
  */
-int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_c2s(int ctlsockfd, tcp_stat_agent agent, TestOptions* testOptions,
              int conn_options, double* c2sspd, int set_buff, int window,
              int autotune, char* device, Options* options, int record_reverse,
              int count_vars, char spds[4][256], int* spd_index) {
+	tcp_stat_connection conn;
+	/* Group only used for web100 */
+	tcp_stat_group group = NULL;
   int recvsfd;  // receiver socket file descriptor
   pid_t c2s_childpid = 0;  // child process pids
   int msgretvalue, tmpbytecount;  // used during the "read"/"write" process
@@ -85,14 +88,12 @@
   char listenc2sport[10];  // listening port
   pthread_t workerThreadId;
 
-  // web_100 related variables
-  web100_group* group = NULL;
-  web100_connection* conn = NULL;
-
   // snap related variables
   SnapArgs snapArgs;
   snapArgs.snap = NULL;
+#ifdef FORCE_WEB100
   snapArgs.log = NULL;
+#endif
   snapArgs.delay = options->snapDelay;
   wait_sig = 0;
 
@@ -253,7 +254,7 @@
     I2Addr src_addr = I2AddrByLocalSockFD(get_errhandle(), recvsfd, 0);
 
     // Get web100 connection. Used to collect web100 variable statistics
-    conn = web100_connection_from_socket(agent, recvsfd);
+    conn = tcp_stat_connection_from_socket(agent, recvsfd);
 
     // set up packet tracing. Collected data is used for bottleneck link
     // calculations
@@ -281,10 +282,13 @@
                     &cli_addr);
         init_pkttrace(src_addr, (struct sockaddr *) &cli_addr, clilen,
                       mon_pipe1, device, &pair, "c2s", options->compress);
+        log_println(1, "C2S is exiting gracefully");
         exit(0); /* Packet trace finished, terminate gracefully */
       }
 
       // Get data collected from packet tracing into the C2S "ndttrace" file
+      /* What is this actually doing? Its seems to be waiting for 
+       * "Ready" to come through on the pipe ?? */
       memset(tmpstr, 0, 256);
       for (i = 0; i < 5; i++) {
         msgretvalue = read(mon_pipe1[0], tmpstr, 128);
@@ -292,7 +296,7 @@
           continue;
         break;
       }
-      if (strlen(tmpstr) > 5)
+     // if (strlen(tmpstr) > 5)
         memcpy(meta.c2s_ndttrace, tmpstr, strlen(tmpstr));
       // name of nettrace file passed back from pcap child
       log_println(3, "--tracefile after packet_trace %s",
@@ -331,6 +335,7 @@
     }
     start_snap_worker(&snapArgs, agent, NULL, options->snaplog, &workerThreadId,
                       meta.c2s_snaplog, options->c2s_logname, conn, group);
+
     // Wait on listening socket and read data once ready.
     tmptime = secs();
     sel_tv.tv_sec = 11;  // time out after 11 seconds
@@ -375,14 +380,20 @@
     // get receiver side Web100 stats and write them to the log file. close
     // sockets
     if (record_reverse == 1)
-      web100_get_data_recv(recvsfd, agent, conn, count_vars);
 
-    close(recvsfd);
-    close(testOptions->c2ssockfd);
+    tcp_stat_get_data_recv(recvsfd, agent, conn, count_vars);
 
+    /*close(recvsfd);
+    close(testOptions->c2ssockfd);*/
+    // Lets move these :)
+
     // Next, send speed-chk a flag to retrieve the data it collected.
     // Skip this step if speed-chk isn't running.
 
+		// Now close sockets once data is recevied
+		close(recvsfd);
+    close(testOptions->c2ssockfd);
+		
     if (getuid() == 0) {
       log_println(1, "Signal USR1(%d) sent to child [%d]", SIGUSR1,
                   c2s_childpid);
@@ -434,7 +445,7 @@
         }
       }
     }
-
+	
     // An empty TEST_FINALIZE message is sent to conclude the test
     send_msg(ctlsockfd, TEST_FINALIZE, "", 0);
 
Index: src/test_s2c_srv.c
===================================================================
--- src/test_s2c_srv.c	(revision 796)
+++ src/test_s2c_srv.c	(working copy)
@@ -25,7 +25,7 @@
 extern pthread_mutex_t mainmutex;
 extern pthread_cond_t maincond;
 
-// used to store file descriptors of pipes created for ndttrace for C2S tests
+// used to store file descriptors of pipes created for ndttrace for S2C tests
 int mon_pipe2[2];
 
 /**
@@ -46,7 +46,7 @@
  * @param testOptions - the test options
  * @param conn_options - the connection options
  * @param testOptions Test options
- * @param s2cspd In-out parameter to store C2S throughput value
+ * @param s2cspd In-out parameter to store S2C throughput value
  * @param set_buff enable setting TCP send/recv buffer size to be used (seems unused in file)
  * @param window value of TCP send/rcv buffer size intended to be used.
  * @param autotune autotuning option. Deprecated.
@@ -70,10 +70,26 @@
  *				-102   - Retries exceeded while waiting for data from connected client
  *  			-errno - Other specific socket error numbers
  */
-int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+
+int test_s2c(int ctlsockfd, tcp_stat_agent agent, TestOptions* testOptions,
              int conn_options, double* s2cspd, int set_buff, int window,
              int autotune, char* device, Options* options, char spds[4][256],
              int* spd_index, int count_vars, CwndPeaks* peaks) {
+#ifdef FORCE_WEB100
+  /* experimental code to capture and log multiple copies of the
+   * web100 variables using the web100_snap() & log() functions.
+   */
+  web100_snapshot* tsnap = NULL;
+  web100_snapshot* rsnap = NULL;
+  web100_group* tgroup;
+  web100_group* rgroup;
+  web100_var* var;
+#else /* web10g */
+  tcpe_data* snap;
+#endif
+  tcp_stat_connection conn;
+  /* Just a holder for web10g */
+  tcp_stat_group group;
   int ret;  // ctrl protocol read/write return status
   int j, k, n;
   int xmitsfd;  // transmit (i.e server) socket fd
@@ -101,16 +117,6 @@
   int sndqueue;
   struct sigaction new, old;
 
-  /* experimental code to capture and log multiple copies of the
-   * web100 variables using the web100_snap() & log() functions.
-   */
-  web100_snapshot* tsnap = NULL;
-  web100_snapshot* rsnap = NULL;
-  web100_group* group;
-  web100_group* tgroup;
-  web100_group* rgroup;
-  web100_connection* conn;
-  web100_var* var;
   pthread_t workerThreadId;
   int nextseqtosend = 0, lastunackedseq = 0;
   int drainingqueuecount = 0, bufctlrnewdata = 0;
@@ -124,7 +130,9 @@
 
   SnapArgs snapArgs;
   snapArgs.snap = NULL;
+#ifdef FORCE_WEB100
   snapArgs.log = NULL;
+#endif
   snapArgs.delay = options->snapDelay;
   wait_sig = 0;
 
@@ -224,7 +232,7 @@
 
     clilen = sizeof(cli_addr);
     FD_ZERO(&rfd);
-    FD_SET(testOptions->c2ssockfd, &rfd);
+    FD_SET(testOptions->s2csockfd, &rfd);
     sel_tv.tv_sec = 5;  // wait for 5 secs
     sel_tv.tv_usec = 0;
     for (j = 0; j < RETRY_COUNT; j++) {
@@ -276,8 +284,9 @@
        }
     }
     src_addr = I2AddrByLocalSockFD(get_errhandle(), xmitsfd, 0);
-    conn = web100_connection_from_socket(agent, xmitsfd);
 
+    conn = tcp_stat_connection_from_socket(agent, xmitsfd);
+
     // set up packet capture. The data collected is used for bottleneck link
     // calculations
     if (xmitsfd > 0) {
@@ -326,8 +335,9 @@
 
       /* experimental code, delete when finished */
       setCwndlimit(conn, group, agent, options);
+
       /* End of test code */
-
+    
       // create directory to write web100 snaplog trace
       create_client_logdir((struct sockaddr *) &cli_addr, clilen,
                            options->s2c_logname, sizeof(options->s2c_logname),
@@ -340,10 +350,15 @@
         // system("/sbin/sysctl -w net.ipv4.route.flush=1");
         system("echo 1 > /proc/sys/net/ipv4/route/flush");
       }
+#ifdef FORCE_WEB100
       rgroup = web100_group_find(agent, "read");
       rsnap = web100_snapshot_alloc(rgroup, conn);
       tgroup = web100_group_find(agent, "tune");
       tsnap = web100_snapshot_alloc(tgroup, conn);
+#else /* Web10g */
+      /* One data snap includes all 'groups' in web10g */
+      tcpe_data_new(&snap);
+#endif
 
       // fill send buffer with random printable data for throughput test
       bytes_written = 0;
@@ -392,6 +407,7 @@
         if (options->avoidSndBlockUp) {  // Do not block send buffers
           pthread_mutex_lock(&mainmutex);
 
+#ifdef FORCE_WEB100
           // get details of next sequence # to be sent and fetch value from
           // snap file
           web100_agent_find_var_and_group(agent, "SndNxt", &group,
@@ -407,6 +423,16 @@
           lastunackedseq = atoi(
               web100_value_to_text(web100_get_var_type(var),
                                    tmpstr));
+#else /* web10g */
+          struct tcpe_val value;
+          // get details of next sequence # to be sent and fetch value from
+          // snap file
+          web10g_find_val(snapArgs.snap, "SndNxt", &value);
+          nextseqtosend = value.uv32;
+          // get oldest un-acked sequence number
+          web10g_find_val(snapArgs.snap, "SndUna", &value);
+          lastunackedseq = value.uv32;
+#endif
           pthread_mutex_unlock(&mainmutex);
 
           // Temporarily stop sending data if you sense that the buffer is
@@ -462,9 +488,12 @@
         log_println(6,
                     "S2C test - failed to send test message to pid=%d",
                     s2c_childpid);
-
+#ifdef FORCE_WEB100
       web100_snap(rsnap);
       web100_snap(tsnap);
+#else /* web10g */
+      tcpe_read_vars(snap, conn, agent);
+#endif
 
       log_println(1, "sent %d bytes to client in %0.2f seconds",
                   (int) bytes_written, tx_duration);
@@ -545,13 +574,18 @@
     /* alarm(30); */
     // Get web100 variables from snapshot taken earlier and send to client
     log_println(6, "S2C-Send web100 data vars to client pid=%d",
-                s2c_childpid);
+                s2c_childpid); 
+#ifdef FORCE_WEB100
     // send web100 data to client
-    ret = web100_get_data(tsnap, ctlsockfd, agent, count_vars);
+    ret = tcp_stat_get_data(tsnap, xmitsfd, ctlsockfd, agent, count_vars);
     web100_snapshot_free(tsnap);
     // send tuning-related web100 data collected to client
-    ret = web100_get_data(rsnap, ctlsockfd, agent, count_vars);
+    ret = tcp_stat_get_data(rsnap, xmitsfd, ctlsockfd, agent, count_vars);
     web100_snapshot_free(rsnap);
+#else /* web10g*/
+    ret = tcp_stat_get_data(snap, xmitsfd, ctlsockfd, agent, count_vars);
+    tcpe_data_free(&snap);
+#endif
 
     // If sending web100 variables above failed, indicate to client
     if (ret < 0) {
Index: src/testoptions.c
===================================================================
--- src/testoptions.c	(revision 796)
+++ src/testoptions.c	(working copy)
@@ -24,11 +24,12 @@
 // Worker thread characteristics used to record snaplog and Cwnd peaks
 typedef struct workerArgs {
   SnapArgs* snapArgs;  // snapArgs struct pointer
-  web100_agent* agent;  // web_100 agent pointer
+  tcp_stat_agent agent;  // web_100/10g agent pointer
   CwndPeaks* peaks;  // data indicating Cwnd values
   int writeSnap;  // enable writing snaplog
 } WorkerArgs;
 
+
 int workerLoop = 0;
 pthread_mutex_t mainmutex = PTHREAD_MUTEX_INITIALIZER;
 pthread_cond_t maincond = PTHREAD_COND_INITIALIZER;
@@ -45,16 +46,28 @@
  * @param snap Web100 snapshot structure
  */
 
+#ifdef FORCE_WEB100
 void findCwndPeaks(web100_agent* agent, CwndPeaks* peaks,
                    web100_snapshot* snap) {
   web100_group* group;
   web100_var* var;
+  char tmpstr[256];
+#else /* Must be web10g */
+void findCwndPeaks(struct tcpe_client * client, CwndPeaks* peaks,
+                   tcpe_data* snap) {
+  struct tcpe_val value;
+#endif
   int CurCwnd;
-  char tmpstr[256];
 
+  
+#ifdef FORCE_WEB100
   web100_agent_find_var_and_group(agent, "CurCwnd", &group, &var);
   web100_snap_read(var, snap, tmpstr);
   CurCwnd = atoi(web100_value_to_text(web100_get_var_type(var), tmpstr));
+#else /* Must be web10g */
+  web10g_find_val(snap, "CurCwnd", &value);
+  CurCwnd = value.uv32;
+#endif
 
   if (slowStart) {
     if (CurCwnd < prevCWNDval) {
@@ -108,9 +121,12 @@
 
 void*
 snapWorker(void* arg) {
+  /* WARNING void* arg i.e workerArgs is on the stack of the function
+   * below and doesn't exist forever start_snap_worker and is valid for
+   * a very short time*/
   WorkerArgs *workerArgs = (WorkerArgs*) arg;
   SnapArgs *snapArgs = workerArgs->snapArgs;
-  web100_agent* agent = workerArgs->agent;
+  tcp_stat_agent agent = workerArgs->agent;
   CwndPeaks* peaks = workerArgs->peaks;
   int writeSnap = workerArgs->writeSnap;
 
@@ -136,6 +152,7 @@
       pthread_mutex_unlock(&mainmutex);
       break;
     }
+#ifdef FORCE_WEB100
     web100_snap(snapArgs->snap);
     if (peaks) {
       findCwndPeaks(agent, peaks, snapArgs->snap);
@@ -143,6 +160,15 @@
     if (writeSnap) {
       web100_log_write(snapArgs->log, snapArgs->snap);
     }
+#else /* Must be web10g */
+    tcpe_read_vars(snapArgs->snap, snapArgs->conn, agent);
+    if (peaks) {
+      findCwndPeaks(agent, peaks, snapArgs->snap);
+    }
+    if (writeSnap) {
+      /* TODO logging */
+    }
+#endif
     pthread_mutex_unlock(&mainmutex);
     mysleep(delay);
   }
@@ -258,21 +284,26 @@
  * @param web100_connection connection pointer
  * @param web100_group group web100_group pointer
  */
-void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
+
+void start_snap_worker(SnapArgs *snaparg, tcp_stat_agent agentarg,
                        CwndPeaks* peaks, char snaplogenabled,
                        pthread_t *wrkrthreadidarg, char *metafilevariablename,
-                       char *metafilename, web100_connection* conn,
-                       web100_group* group) {
+                       char *metafilename, tcp_stat_connection conn,
+                       tcp_stat_group group) {
   FILE *fplocal;
 
   WorkerArgs workerArgs;
   workerArgs.snapArgs = snaparg;
-  workerArgs.agent = agentarg;
   workerArgs.peaks = peaks;
   workerArgs.writeSnap = snaplogenabled;
-
+  workerArgs.agent = agentarg;
+  snaparg->conn = conn; // Not actaully used by web100
+#ifdef FORCE_WEB100 
   group = web100_group_find(agentarg, "read");
   snaparg->snap = web100_snapshot_alloc(group, conn);
+#else /* web10g */
+  tcpe_data_new(&snaparg->snap);
+#endif
 
   if (snaplogenabled) {
     // memcpy(metafilevariablename, metafilename, strlen(metafilename));
@@ -280,7 +311,9 @@
     // just the file name, but full filename is needed to open the log file
 
     fplocal = fopen(get_logfile(), "a");
+#ifdef FORCE_WEB100
     snaparg->log = web100_log_open_write(metafilename, conn, group);
+#endif /* TODO web10g logging */
     if (fplocal == NULL) {
       log_println(
           0,
@@ -302,10 +335,16 @@
   pthread_mutex_lock(&mainmutex);
   workerLoop= 1;
   // obtain web100 snap into "snaparg.snap"
+#ifdef FORCE_WEB100
   web100_snap(snaparg->snap);
   if (snaplogenabled) {
     web100_log_write(snaparg->log, snaparg->snap);
   }
+#else /* web10g */
+  tcpe_read_vars(snaparg->snap, conn, agentarg);
+  /* TODO logging */
+#endif
+
   pthread_cond_wait(&maincond, &mainmutex);
   pthread_mutex_unlock(&mainmutex);
 }
@@ -325,11 +364,17 @@
     pthread_join(*workerThreadId, NULL);
   }
   // close writing snaplog, if snaplog recording is enabled
+#ifdef FORCE_WEB100
   if (snaplogenabled) {
     web100_log_close_write(snapArgs_ptr->log);
   }
+#endif /* TODO web10g */
 
+#ifdef FORCE_WEB100
   web100_snapshot_free(snapArgs_ptr->snap);
+#else /* web10g */
+  tcpe_data_free(&snapArgs_ptr->snap);
+#endif 
 }
 
 /**
@@ -415,9 +460,14 @@
  * @param group_arg web100 group pointer
  * @param agentarg web100 agent pointer
  * */
-void setCwndlimit(web100_connection* connarg, web100_group* grouparg,
-                  web100_agent* agentarg, Options* optionsarg) {
+
+void setCwndlimit(tcp_stat_connection connarg, tcp_stat_group grouparg,
+                  tcp_stat_agent agentarg, Options* optionsarg) {
+#ifdef FORCE_WEB100
   web100_var *LimRwin, *yar;
+#else /* web10g */
+  struct tcpe_val LimRwin, yar;
+#endif 
   u_int32_t limrwin_val;
   char yuff[32];
 
@@ -427,6 +477,7 @@
     if (connarg != NULL) {
       log_println(1,
                   "Got web100 connection pointer for recvsfd socket\n");
+#ifdef FORCE_WEB100 
       web100_agent_find_var_and_group(agentarg, "CurMSS", &grouparg,
                                       &yar);
       web100_raw_read(yar, connarg, yuff);
@@ -442,6 +493,15 @@
       log_print(1, "now write %d to limit the Receive window",
                 limrwin_val);
       web100_raw_write(LimRwin, connarg, &limrwin_val);
+#else /* web10g */
+      web10g_get_val(agentarg, connarg, "CurMSS", &yar);
+      log_println(1, "MSS = %s, multiplication factor = %d", yar.uv32 , 
+                  optionsarg->limit);
+      limrwin_val = optionsarg->limit * yar.uv32;
+      log_print(1, "now write %d to limit the Receive window", 
+                limrwin_val);
+      tcpe_write_var("LimRwin", limrwin_val , connarg, agentarg);
+#endif
       log_println(1, "  ---  Done");
     }
   }
Index: src/testoptions.h
===================================================================
--- src/testoptions.h	(revision 796)
+++ src/testoptions.h	(working copy)
@@ -47,11 +47,13 @@
 
 // Snap log characteristics
 typedef struct snapArgs {
-  web100_snapshot* snap;  // web_100 snapshot indicator
-  web100_log* log;  // web_100 log
+  tcp_stat_connection conn; // Only needed by web10g
+  tcp_stat_snap snap;  // web_100 snapshot indicator
+  tcp_stat_log log;  // web_100 log (TODO - not used by 10g yet)
   int delay;  // periodicity, in ms, of collecting snap
 } SnapArgs;
 
+
 int wait_sig;
 
 int initialize_tests(int ctlsockfd, TestOptions* testOptions,
@@ -59,27 +61,24 @@
 
 void catch_s2c_alrm(int signo);
 
-int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_sfw_srv(int ctlsockfd, tcp_stat_agent agent, TestOptions* options,
                  int conn_options);
-int test_meta_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_meta_srv(int ctlsockfd, tcp_stat_agent not_usedagent, TestOptions* testOptions,
                   int conn_options);
+void start_snap_worker(SnapArgs *snaparg, tcp_stat_agent agentarg,
+                       CwndPeaks* peaks, char snaplogenabled,
+                       pthread_t *wrkrthreadidarg, char *metafilevariablename,
+                       char *metafilename, tcp_stat_connection conn,
+                       tcp_stat_group group);
+void setCwndlimit(tcp_stat_connection connarg, tcp_stat_group grouparg,
+                  tcp_stat_agent agentarg, Options* optionsarg);
 
 int getCurrentTest();
 void setCurrentTest(int testId);
 
-// void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
-void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
-                       CwndPeaks* peaks, char snaplogenabled,
-                       pthread_t *wrkrthreadidarg, char *metafilevariablename,
-                       char *metafilename, web100_connection* conn,
-                       web100_group* group);
-
 void stop_snap_worker(pthread_t *workerThreadId, char snaplogenabled,
                       SnapArgs* snapArgs_ptr);
 
-void setCwndlimit(web100_connection* connarg, web100_group* grouparg,
-                  web100_agent* agentarg, Options* optionsarg);
-
 int is_buffer_clogged(int nextseqtosend, int lastunackedseq);
 void stop_packet_trace(int *monpipe_arr);
 
Index: src/test_mid_srv.c
===================================================================
--- src/test_mid_srv.c	(revision 796)
+++ src/test_mid_srv.c	(working copy)
@@ -9,7 +9,7 @@
  *      Author: kkumar
  */
 
-#include  <syslog.h>
+#include <syslog.h>
 #include <pthread.h>
 #include <sys/times.h>
 #include <assert.h>
@@ -48,8 +48,7 @@
  *				3 Ð Received message is invalid
  *
  */
-
-int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_mid(int ctlsockfd, tcp_stat_agent agent, TestOptions* options,
              int conn_options, double* s2c_throughput_mid) {
   int maxseg = ETHERNET_MTU_SIZE;
   /* int maxseg=1456, largewin=16*1024*1024; */
@@ -66,7 +65,9 @@
   char listenmidport[10];  // listener socket for middlebox tests
   int msgType;
   int msgLen;
-  web100_connection* conn;
+
+  tcp_stat_connection conn;
+  
   char tmpstr[256];  // temporary string storage
   struct timeval sel_tv;  // time
   fd_set rfd;  // receiver file descriptor
@@ -236,7 +237,7 @@
 
     buff[0] = '\0';
     // get web100 connection data
-    if ((conn = web100_connection_from_socket(agent, midsfd)) == NULL) {
+    if ((conn = tcp_stat_connection_from_socket(agent, midsfd)) == 0) {
       log_println(
           0,
           "!!!!!!!!!!!  test_mid() failed to get web100 connection data, rc=%d",
@@ -246,7 +247,7 @@
     }
 
     // Perform S->C throughput test. Obtained results in "buff"
-    web100_middlebox(midsfd, agent, conn, buff, sizeof(buff));
+    tcp_stat_middlebox(midsfd, agent, conn, buff, sizeof(buff));
 
     // Transmit results in the form of a TEST_MSG message
     send_msg(ctlsockfd, TEST_MSG, buff, strlen(buff));
Index: src/usage.c
===================================================================
--- src/usage.c	(revision 796)
+++ src/usage.c	(working copy)
@@ -69,6 +69,7 @@
   printf("  -L, --log_dir DIR      - specify the base directory for snaplog and tcpdump files\n");
   printf("                           (default %s/serverdata)\n", BASEDIR);
   printf("  -S, --logfacility #F   - specify syslog facility name\n");
+  printf("  -k, --kernelconfig     - Automatically configure kernel settings for best results\n");
   printf("                           Note: this doesn't enable 'syslog'\n\n");
 #ifdef EXPERIMENTAL_ENABLED
   printf(" Experimental code:\n\n");
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 796)
+++ src/Makefile.am	(working copy)
@@ -25,7 +25,7 @@
 if HAVE_WEB100
 bin_PROGRAMS = web100clt analyze viewtrace tr-mkmap genplot
 if HAVE_PCAP_H
-sbin_PROGRAMS = fakewww web100srv 
+sbin_PROGRAMS = fakewww web100srv
 else
 sbin_PROGRAMS = fakewww
 endif
@@ -33,6 +33,22 @@
 bin_PROGRAMS = web100clt
 endif
 
+if HAVE_TCPE
+if HAVE_WEB100
+if HAVE_PCAP_H
+sbin_PROGRAMS += web10gsrv
+endif
+endif
+endif
+
+if HAVE_TCPE
+if !HAVE_WEB100
+if HAVE_PCAP_H
+sbin_PROGRAMS = fakewww web10gsrv
+endif
+endif
+endif
+
 web100clt_SOURCES = web100clt.c network.c usage.c logging.c utils.c protocol.c runningtest.c ndtptestconstants.c \
                     test_sfw_clt.c test_mid_clt.c test_c2s_clt.c test_s2c_clt.c test_meta_clt.c strlutils.c \
 			test_results_clt.c
@@ -46,7 +62,7 @@
 
 analyze_SOURCES = analyze.c usage.c logging.c runningtest.c ndtptestconstants.c strlutils.c
 analyze_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
-analyze_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+analyze_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 
 fakewww_SOURCES = fakewww.c troute.c troute6.c tr-tree.c tr-tree6.c network.c usage.c logging.c \
 	 runningtest.c ndtptestconstants.c strlutils.c
@@ -56,15 +72,24 @@
 web100srv_SOURCES = web100srv.c web100-util.c web100-pcap.c web100-admin.c runningtest.c \
                     network.c usage.c utils.c mrange.c logging.c testoptions.c ndtptestconstants.c \
                     protocol.c test_sfw_srv.c test_meta_srv.c ndt_odbc.c strlutils.c heuristics.c \
-		    test_c2s_srv.c test_s2c_srv.c test_mid_srv.c
+		    test_c2s_srv.c test_s2c_srv.c test_mid_srv.c kernel_coalesce.c kernel_config.c
 web100srv_LDFLAGS = $(NDTLDFLAGS) $(I2UTILLDFLAGS)
 web100srv_LDADD = $(NDTLIBS) $(I2UTILLIBS) $(I2UTILLIBDEPS) -lpthread $(ZLIB)
-web100srv_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+web100srv_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 web100srv_DEPENDENCIES = $(I2UTILLIBDEPS)
 
+web10gsrv_SOURCES = web100srv.c web100-util.c web100-pcap.c web100-admin.c runningtest.c \
+                    network.c usage.c utils.c mrange.c logging.c testoptions.c ndtptestconstants.c \
+                    protocol.c test_sfw_srv.c test_meta_srv.c ndt_odbc.c strlutils.c heuristics.c \
+		    test_c2s_srv.c test_s2c_srv.c test_mid_srv.c kernel_coalesce.c kernel_config.c web10g-util.c
+web10gsrv_LDFLAGS = $(NDTLDFLAGS) $(I2UTILLDFLAGS)
+web10gsrv_LDADD = $(NDTLIBS) $(I2UTILLIBS) $(I2UTILLIBDEPS) -lpthread $(ZLIB)
+web10gsrv_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+web10gsrv_DEPENDENCIES = $(I2UTILLIBDEPS)
+
 viewtrace_SOURCES = viewtrace.c usage.c logging.c utils.c runningtest.c ndtptestconstants.c strlutils.c
 viewtrace_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
-viewtrace_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+viewtrace_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 
 tr_mkmap_SOURCES = tr-mkmap.c tr-tree.c tr-tree6.c usage.c logging.c runningtest.c ndtptestconstants.c strlutils.c
 tr_mkmap_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
@@ -88,5 +113,5 @@
 
 EXTRA_DIST = clt_tests.h logging.h mrange.h network.h protocol.h testoptions.h test_sfw.h test_meta.h \
              troute.h tr-tree.h usage.h utils.h varinfo.h web100-admin.h web100srv.h ndt_odbc.h runningtest.h ndtptestconstants.h \
-	     heuristics.h strlutils.h test_results_clt.h tests_srv.h
+	     heuristics.h strlutils.h test_results_clt.h tests_srv.h kernel_coalesce.h kernel_config.h
 
